

#include <tigcclib.h>         // Include All Header Files
#include "cgl.h"




short display_dirty;

void init()
{

	display_dirty = TRUE;


	if( GL_INIT() ) {
		exit(-1);
	}


	glViewport(1, 1, BACK_BUFFER_WIDTH - 2, BACK_BUFFER_HEIGHT -2);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(45.0f, (float) LCD_WIDTH/ (float) LCD_HEIGHT, 1.0 ,150.0f);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(10, 6, 10,     0, 3, 0,     0, 1, 0);

	glClearColor(3);

}





void input()
{

	const float LINEAR_SPEED = 5.0;
	const float ANGULAR_SPEED = 20.0;

	short esc = FALSE;

	float y_rotation = 0;
	float z_translation = 0;

	BEGIN_KEYTEST

		y_rotation -= _keytest_optimized (RR_LEFT) * ANGULAR_SPEED;
		y_rotation += _keytest_optimized (RR_RIGHT) * ANGULAR_SPEED;

		z_translation += _keytest_optimized (RR_UP) * LINEAR_SPEED;
		z_translation -= _keytest_optimized (RR_DOWN) * LINEAR_SPEED;

		esc = _keytest_optimized (RR_ESC);

	END_KEYTEST


	float m[16];

	if( y_rotation != 0 ) {

		glGetFloatv(GL_MODELVIEW_MATRIX, m);
		glLoadIdentity();
		glRotatef(y_rotation, m[4], m[5], m[6]);
		glMultMatrixf(m);

		display_dirty = TRUE;
	}


	if( z_translation != 0 ) {

		glGetFloatv(GL_MODELVIEW_MATRIX, m);
		float length = sqrt( m[2] * m[2] + m[10] * m[10] );
		z_translation /= length;
		glTranslatef(z_translation * m[2], 0 /*3 * m[6]*/, z_translation * m[10]);

		display_dirty = TRUE;
	}


	if(esc){

		GL_DEINIT();
		exit(0);
	}


}





void update()
{


}







void tetrahedron(fl0at min_x, fl0at min_y, fl0at min_z, fl0at edge_length, unsigned char iterations_left)
{

	fl0at half_length = fldiv( edge_length, make_fl0at_s(2) );


	void render_single_tetrahedron()
	{

		glBegin(GL_TRIANGLES);

			glVertex3f0( min_x, min_y, min_z);
			glVertex3f0( fladd( min_x, half_length ) , fladd( min_y , edge_length ) , fladd( min_z, half_length) );
			glVertex3f0( fladd( min_x , edge_length ) , min_y, min_z);

			glVertex3f0( min_x, min_y, min_z);
			glVertex3f0( fladd( min_x , half_length ) , min_y, fladd( min_z, edge_length) );
			glVertex3f0( fladd( min_x, half_length ) , fladd( min_y , edge_length ) , fladd( min_z, half_length) );

			glVertex3f0( fladd( min_x , half_length ) , min_y, fladd( min_z, edge_length) );
			glVertex3f0( fladd( min_x , edge_length ) , min_y, min_z);
			glVertex3f0( fladd( min_x, half_length ) , fladd( min_y , edge_length ) , fladd( min_z, half_length) );

			glVertex3f0( min_x, min_y, min_z);
			glVertex3f0( fladd( min_x , edge_length) , min_y, min_z);
			glVertex3f0( fladd( min_x , half_length) , min_y, fladd( min_z, edge_length) );

		glEnd();

	}




	if(!iterations_left) {


		glEnable(GL_POLYGON_OFFSET_POINT);
		glEnable(GL_POLYGON_OFFSET_LINE);


	//		glPolygonOffset(-60);

	//	unsigned char x,y;
	//		glColor(black);


		glEnable(GL_CULL_FACE);
		glFrontFace(GL_CCW);
		glCullFace(GL_BACK);


		glPolygonOffset(-60);
		glPolygonMode(GL_FRONT_AND_BACK, GL_POINT);


		glColor(white);
//		render_single_tetrahedron();


		glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
		glPolygonOffset(-30);

		glColor(dark);
		render_single_tetrahedron();

		glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);

//		glPolygonOffset(0);

		glColor(white);
		render_single_tetrahedron();




	}
	else {

		--iterations_left;

		fl0at quarter_length = fldiv( half_length, make_fl0at_s(2) );

		tetrahedron( min_x,  min_y,  min_z,  half_length,  iterations_left );
		tetrahedron( fladd( min_x , half_length ) ,  min_y,  min_z,  half_length,  iterations_left );
		tetrahedron( fladd( min_x , quarter_length ) ,  min_y, fladd( min_z , half_length ),  half_length,  iterations_left );
		tetrahedron( fladd( min_x , quarter_length ) ,  fladd( min_y , half_length ) ,  fladd( min_z , quarter_length ) ,  half_length,  iterations_left );

	}


}









void render()
{
	if(display_dirty == FALSE){
		return;
	}

	display_dirty = FALSE;

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	// Clear Screen And Depth Buffer



	glCullFace(GL_BACK);
	glFrontFace(GL_CCW);
	glEnable(GL_CULL_FACE);



	SwapBuffers();

	glPushMatrix();

		glScalef(1,1,1);

			glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
			glColor( black );
			tetrahedron( make_fl0at_s(0) , make_fl0at_s(0) , make_fl0at_s(0) , make_fl0at_s(10) , 4);
			SwapBuffers();


			glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
			glPolygonOffset(-20);
			glEnable(GL_POLYGON_OFFSET_LINE);
			glColor( white );
	//		wire_tetrahedron( make_fl0at_s(0) , make_fl0at_s(0) , make_fl0at_s(0) , make_fl0at_s(10) , 3);


	glPopMatrix();


	SwapBuffers();


}





void _main(void)
{



	init();





	while(1){
		input();
		update();
		render();
	}
}





