// fl0at floating point routines by David Teitlebaum
// these are optimized for speed, not accuracy
// get the header for this file out of the cgl.h header


inline void reshift( unsigned long* mantissa, char* exponent )
{
	char shift;


//	if( *mantissa ) {
	if( *mantissa & 0xFFFF0000 ) {
		if( *mantissa & 0xFF000000 ) {
			if( *mantissa & 0xF0000000 ) {
				if( *mantissa & 0xC0000000 ) {
					if( *mantissa & 0x80000000 ) {
						shift = 16;
					}
					else { // mantissa & 0x40000000
						shift = 15;
					}
				}
				else { // mantissa & 0x300000000
					if( *mantissa & 0x20000000 ) {
						shift = 14;
					}
					else {
						shift = 13;
					}
				}
			}
			else {	// mantissa & 0x0F000000
				if( *mantissa & 0x0C000000 ) {
					if( *mantissa & 0x08000000 ) {
						shift = 12;
					}
					else { // mantissa & 0x40000000
						shift = 11;
					}
				}
				else { // mantissa & 0x300000000
					if( *mantissa & 0x02000000 ) {
						shift = 10;
					}
					else {
						shift = 9;
					}
				}
			}
		}
		else {	// mantissa & 0x00FF0000

			if( *mantissa & 0x00F00000 ) {
				if( *mantissa & 0x00C00000 ) {
					if( *mantissa & 0x00800000 ) {
						shift = 8;
					}
					else { // mantissa & 0x40000000
						shift = 7;
					}
				}
				else { // mantissa & 0x300000000
					if( *mantissa & 0x00200000 ) {
						shift = 6;
					}
					else {
						shift = 5;
					}
				}
			}
			else {	// mantissa & 0x0F000000
				if( *mantissa & 0x000C0000 ) {
					if( *mantissa & 0x00080000 ) {
						shift = 4;
					}
					else { // mantissa & 0x40000000
						shift = 3;
					}
				}
				else { // mantissa & 0x300000000
					if( *mantissa & 0x00020000 ) {
						shift = 2;
					}
					else {
						shift = 1;
					}
				}
			}
		}

		*mantissa >>= shift;
		*exponent += shift;

	}
	else {	// mantissa & 0x0000FFFF

		if( !( *mantissa & 0x8000 ) ) {

			if( *mantissa & 0x00007F00 ) {
				if( *mantissa & 0x00007000 ) {
					if( *mantissa & 0x00004000 ) {
		/*				if( *mantissa & 0x00008000 ) {
							return;
						}
						else { // mantissa & 0x40000000
		*/					shift = 1;
		//				}
					}
					else { // mantissa & 0x300000000
						if( *mantissa & 0x00002000 ) {
							shift = 2;
						}
						else {
							shift = 3;
						}
					}
				}
				else {	// mantissa & 0x0F000000
					if( *mantissa & 0x00000C00 ) {
						if( *mantissa & 0x00000800 ) {
							shift = 4;
						}
						else { // mantissa & 0x40000000
							shift = 5;
						}
					}
					else { // mantissa & 0x300000000
						if( *mantissa & 0x00000200 ) {
							shift = 6;
						}
						else {
							shift = 7;
						}
					}
				}
			}
			else {	// mantissa & 0x00FF0000

				if( *mantissa & 0x000000F0 ) {
					if( *mantissa & 0x000000C0 ) {
						if( *mantissa & 0x00000080 ) {
							shift = 8;
						}
						else { // mantissa & 0x40000000
							shift = 9;
						}
					}
					else { // mantissa & 0x300000000
						if( *mantissa & 0x00000020 ) {
							shift = 10;
						}
						else {
							shift = 11;
						}
					}
				}
				else {	// mantissa & 0x0F000000
					if( *mantissa & 0x0000000C ) {
						if( *mantissa & 0x00000008 ) {
							shift = 12;
						}
						else { // mantissa & 0x40000000
							shift = 13;
						}
					}
					else { // mantissa & 0x300000000
						if( *mantissa & 0x00000002 ) {
							shift = 14;
						}
						else {
							shift = 15;
						}
					}
				}
			}

			*mantissa <<= shift;
			*exponent -= shift;

		}

	}

}









inline void reshift_left( unsigned short* mantissa, char* exponent )
{
	char shift;


//	if( *mantissa ) {
	if( !( *mantissa & 0x8000 ) ) {
		if( *mantissa & 0x7F00 ) {
			if( *mantissa & 0x7000 ) {
				if( *mantissa & 0x4000 ) {
/*					if( *mantissa & 0x8000 ) {
						return;
					}
					else { // mantissa & 0x40000000
*/						shift = 1;
//					}
				}
				else { // mantissa & 0x300000000
					if( *mantissa & 0x2000 ) {
						shift = 2;
					}
					else {
						shift = 3;
					}
				}
			}
			else {	// mantissa & 0x0F000000
				if( *mantissa & 0x0C00 ) {
					if( *mantissa & 0x0800 ) {
						shift = 4;
					}
					else { // mantissa & 0x40000000
						shift = 5;
					}
				}
				else { // mantissa & 0x300000000
					if( *mantissa & 0x0200 ) {
						shift = 6;
					}
					else {
						shift = 7;
					}
				}
			}
		}
		else {	// mantissa & 0x00FF0000

			if( *mantissa & 0x00F0 ) {
				if( *mantissa & 0x00C0 ) {
					if( *mantissa & 0x0080 ) {
						shift = 8;
					}
					else { // mantissa & 0x40000000
						shift = 9;
					}
				}
				else { // mantissa & 0x300000000
					if( *mantissa & 0x0020 ) {
						shift = 10;
					}
					else {
						shift = 11;
					}
				}
			}
			else {	// mantissa & 0x0F000000
				if( *mantissa & 0x000C ) {
					if( *mantissa & 0x0008 ) {
						shift = 12;
					}
					else { // mantissa & 0x40000000
						shift = 13;
					}
				}
				else { // mantissa & 0x300000000
					if( *mantissa & 0x0002 ) {
						shift = 14;
					}
					else {
						shift = 15;
					}
				}
			}
		}

		*mantissa <<= shift;
		*exponent -= shift;

	}

}




fl0at make_fl0at( BOOL sign, char exponent, unsigned short mantissa )
{
	fl0at a;

	if( mantissa ){

		a.sign = sign;
		a.exponent = exponent;
		a.mantissa = mantissa;


		reshift_left( &a.mantissa, &a.exponent );


	}
	else {
		a.exponent = 0;
		a.mantissa = 0;
		a.sign = 0;
	}

	return a;
}







short fl0at_to_short( fl0at f )
{

	short b = f.mantissa >> 1;
	f.exponent += 1;

	if( f.sign == NEGATIVE ) {
		b = -b;
	}

	if( f.exponent > 0 ) {
		b <<= f.exponent;
	}
	else if (f.exponent < 0) {
		b >>= -f.exponent;
	}


	return b;
}









fl0at make_fl0at_s( short mantissa )
{
	fl0at a;

	if( mantissa ){

		if(mantissa < 0) {
			a.sign = NEG;
			a.mantissa = -mantissa;
		}
		else {
			a.sign = POS;
			a.mantissa = mantissa;
		}

		a.exponent = 0;

		reshift_left( &a.mantissa, &a.exponent );
	}
	else {
		a.exponent = 0;
		a.mantissa = 0;
		a.sign = 0;
	}

	return a;
}





long fl0at_to_long( fl0at f )
{

	long b = f.mantissa;

	if( f.sign == NEGATIVE ) {
		b = -b;
	}

	if( f.exponent > 0 ) {
		b <<= f.exponent;
	}
	else if (f.exponent < 0) {
		b >>= -f.exponent;
	}


	return b;
}













fl0at make_fl0at_l( long mantissa )
{
	fl0at a;

	if( mantissa ){

		if(mantissa < 0) {
			a.sign = NEG;
			mantissa = -mantissa;
		}
		else {
			a.sign = POS;
		}

		a.exponent = 0;


		reshift( &mantissa, &a.exponent );


		a.mantissa = mantissa;
	}
	else {
		a.exponent = 0;
		a.mantissa = 0;
		a.sign = 0;
	}

	return a;
}














fl0at float_to_fl0at( float f )
{

	BOOL sign;

	if( f < 0 ) {
		sign = NEGATIVE;
		f *= -1;
	}
	else {
		sign = POSITIVE;
	}

	char exponent = log( f ) / 0.69314718055994528622676398299518041312694549560546875;



	++exponent;

	f /= pow(2, exponent);
	f *= 65536;

	exponent -= 16;

	unsigned short mantissa = f;



	if( mantissa ){

		reshift_left( &mantissa, &exponent );

	}
	else {
		exponent = 0;
		mantissa = 0;
		sign = 0;
	}



	fl0at b;
	b.sign = sign;
	b.exponent = exponent;
	b.mantissa = mantissa;

	return b;
}





float fl0at_to_float( fl0at f )
{
	float b = f.mantissa;

	if( f.sign == NEGATIVE ) {
		b = -b;
	}

	b *= pow(2, f.exponent);

	return b;
}












fl0at fladd(fl0at a, fl0at b)
{

	if(a.exponent < b.exponent) {
		fl0at c = a;
		a = b;
		b = c;
	}


	long a_mantissa = a.mantissa;
	long b_mantissa = b.mantissa;

	if( a.sign == NEGATIVE ) {
		a_mantissa = -a_mantissa;
	}

	if( b.sign == NEGATIVE ) {
		b_mantissa = -b_mantissa;
	}

	a_mantissa <<= 14;	// need room for an overflow mangitude bit, plus a sign bit


	short left_shift_count = (b.exponent - a.exponent) + 14;

	if( left_shift_count > 0 ) {
		b_mantissa <<= left_shift_count;
	}
	else {	// true when a.exponent > b.exponent + 14
		b_mantissa >>= -left_shift_count;
	}

	long c_mantissa = a_mantissa + b_mantissa;	// here's the actual addition

	fl0at c;

	if( c_mantissa ){

		c.exponent = a.exponent - 14;

		if( c_mantissa < 0 ) {
			c_mantissa = -c_mantissa;
			c.sign = NEGATIVE;
		}
		else {
			c.sign = POSITIVE;
		}


		reshift( &c_mantissa, &c.exponent );


		c.mantissa = c_mantissa;
	}
	else {
		c.exponent = 0;
		c.mantissa = 0;
		c.sign = 0;
	}

	return c;
}







fl0at flsub(fl0at a, fl0at b)
{
	b.sign = !b.sign;
	return fladd( a, b );
}






fl0at flmult(fl0at a, fl0at b)
{

	unsigned long a_mantissa = a.mantissa;
	unsigned long b_mantissa = b.mantissa;

	unsigned long c_mantissa = a_mantissa * b_mantissa;

	fl0at c;

	if( c_mantissa ){

		c.exponent = a.exponent + b.exponent;


		if( c_mantissa & 0x80000000 ) {
			c_mantissa >>= 16;
			c.exponent += 16;
		}
		else {
			c_mantissa >>= 15;
			c.exponent += 15;
		}

		c.mantissa = c_mantissa;
		c.sign = a.sign ^ b.sign;
	}
	else {
		c.exponent = 0;
		c.mantissa = 0;
		c.sign = 0;
	}

	return c;
}





fl0at fldiv(fl0at a, fl0at b)
{

	unsigned long a_mantissa = a.mantissa;
	unsigned long b_mantissa = b.mantissa;

	a_mantissa <<= 16;
	unsigned long c_mantissa = (a_mantissa / b_mantissa);

	fl0at c;

	if( c_mantissa ){

		c.exponent = a.exponent - b.exponent - 16;


		if(c_mantissa & 0x10000) {
			c_mantissa >>= 1;
			++c.exponent;
		}


		c.mantissa = c_mantissa;
		c.sign = a.sign ^ b.sign;
	}
	else {
		c.exponent = 0;
		c.mantissa = 0;
		c.sign = 0;
	}

	return c;
}







BOOL fl_less_than(fl0at a, fl0at b)
{
	fl0at c = flsub(a, b);
	return c.sign;	// neg = 1, so a pos or zero result will return false
}




BOOL fl_greater_than(fl0at a, fl0at b)
{
	fl0at c = flsub(b, a);
	return c.sign;	// neg = 1, so a pos or zero result will return false
}



BOOL fl_less_than_or_equals(fl0at a, fl0at b)
{
	fl0at c = flsub(b, a);
	return !c.sign;
}



BOOL fl_greater_than_or_equals(fl0at a, fl0at b)
{
	fl0at c = flsub(a, b);
	return !c.sign;	// neg = 1, so a pos or zero result will return false
}



BOOL fl_equals(fl0at a, fl0at b)
{
	return( (a.mantissa == b.mantissa) && (a.sign == b.sign) && (a.exponent == b.exponent) );
}




fl0at fl_abs(fl0at a)
{
	a.sign = 0;
	return a;
}




fl0at flnegate( fl0at a )
{
	if(a.mantissa) {
		a.sign = !a.sign;
	}
	return a;
}










